package fr.smallcrew.utils;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;

import java.util.Map;
import java.util.Properties;

import static com.google.common.collect.Maps.newHashMap;

public class CustomPropertyPlaceholderConfigurer extends PropertyPlaceholderConfigurer {
  private final Map<String, String> properties;

  public CustomPropertyPlaceholderConfigurer() {
    properties = newHashMap();
  }

  @Override
  protected void processProperties(ConfigurableListableBeanFactory beanFactory, Properties props) throws BeansException {
    super.processProperties(beanFactory, props);
    for (Object key : props.keySet()) {
      String keyStr = key.toString();
      String value = resolvePlaceholder(keyStr, props, SYSTEM_PROPERTIES_MODE_FALLBACK);
      properties.put(keyStr, value);
    }
  }

  public Map<String, String> getProperties() {
    return properties;
  }
}
